PROGRAM Compute_Sigma
  USE linearpk
  USE sigma
  ! A sample program for computing sigma(Rh) and dln(sigma)/dlnRh
  ! August 23, 2008: E.Komatsu
  IMPLICIT none
  real :: chebev
  real :: lnsigma2,lnRh,Rh,dlnsigma2dlnRh
  character(len=128) :: filename
  integer :: n
! read in and tabulate P(k)
  filename='wmap5baosn_max_likelihood_matterpower.dat'
  n=896 ! # of lines in the file
  CALL open_linearpk(filename,n)
! fit sigma^2(R) to Chebyshev polynomials
  CALL compute_sigma2
  CALL close_linearpk
! now output sigma(R) and dln(sigma)/dlnR as a function of R [h^-1 Mpc]...'
  open(1,file='Rh_sigma.txt')
  open(2,file='Rh_dlnsigmadlnRh.txt')
  do lnRh=lnR1,lnR2,0.01
     lnsigma2 = CHEBEV(lnR1,lnR2,c,ndim,lnRh)
     Rh=exp(lnRh) ! h^-1 Mpc
     write(1,'(2E13.5)') Rh,exp(0.5*lnsigma2)
     dlnsigma2dlnRh = CHEBEV(lnR1,lnR2,cder,ndim,lnRh)
     write(2,'(2E13.5)') Rh,0.5*dlnsigma2dlnRh
  enddo
  close(1)
  close(2)
END PROGRAM Compute_Sigma
