PROGRAM Compute_Sigma
  USE cosmo
  USE linearpk
  USE sigma
  USE growth
  ! A sample program for computing sigma(Rh) and dln(sigma)/dlnRh
  ! at some redshift. Note that dln(sigma)/dlnRh is independent of z.
  ! August 24, 2008: E.Komatsu
  IMPLICIT none
  real :: chebev
  real :: lnsigma2,lnRh,Rh,dlnsigma2dlnRh
  double precision :: zin,zout,g,scalefactor
  character(len=128) :: filename
  integer :: n
  external g
! Specify three cosmological parameters
! The data type has been defined in MODULE cosmo.
  ode0=0.723d0
  om0=0.277d0
  w=-1d0
! read in and tabulate P(k)
  filename='wmap5baosn_max_likelihood_matterpower_at_z=30.dat'
  n=896 ! # of lines in the file
  CALL open_linearpk(filename,n)
  zin=30d0
! fit sigma^2(R) to Chebyshev polynomials
  CALL compute_sigma2
  CALL close_linearpk
! ask for the output redshift
  print*,'output redshift?'
  read*,zout
! compute the growth factor
  CALL setup_growth
  scalefactor=g(zout)/g(zin)*(1d0+zin)/(1d0+zout)
  print*,'omega matter=',om0
  print*,'omega de=',ode0
  print*,'w=',w
! now output sigma(R) and dln(sigma)/dlnR as a function of R [h^-1 Mpc]...'
  open(1,file='Rh_sigma.txt')
  open(2,file='Rh_dlnsigmadlnRh.txt')
  do lnRh=lnR1,lnR2,0.01
     lnsigma2 = CHEBEV(lnR1,lnR2,c,ndim,lnRh)
     Rh=exp(lnRh) ! h^-1 Mpc
     write(1,'(2E13.5)') Rh,exp(0.5*lnsigma2)*scalefactor
     dlnsigma2dlnRh = CHEBEV(lnR1,lnR2,cder,ndim,lnRh)
     write(2,'(2E13.5)') Rh,0.5*dlnsigma2dlnRh
  enddo
  close(1)
  close(2)
END PROGRAM Compute_Sigma
